<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVehicleActivityInfoItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfVehicleActivityInfoItem extends AbstractStructArrayBase
{
    /**
     * The VehicleActivityInfoItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VehicleActivityInfoItem[]
     */
    public $VehicleActivityInfoItem;
    /**
     * Constructor method for ArrayOfVehicleActivityInfoItem
     * @uses ArrayOfVehicleActivityInfoItem::setVehicleActivityInfoItem()
     * @param \StructType\VehicleActivityInfoItem[] $vehicleActivityInfoItem
     */
    public function __construct(array $vehicleActivityInfoItem = array())
    {
        $this
            ->setVehicleActivityInfoItem($vehicleActivityInfoItem);
    }
    /**
     * Get VehicleActivityInfoItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VehicleActivityInfoItem[]|null
     */
    public function getVehicleActivityInfoItem()
    {
        return isset($this->VehicleActivityInfoItem) ? $this->VehicleActivityInfoItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setVehicleActivityInfoItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVehicleActivityInfoItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVehicleActivityInfoItemForArrayConstraintsFromSetVehicleActivityInfoItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfVehicleActivityInfoItemVehicleActivityInfoItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleActivityInfoItemVehicleActivityInfoItemItem instanceof \StructType\VehicleActivityInfoItem) {
                $invalidValues[] = is_object($arrayOfVehicleActivityInfoItemVehicleActivityInfoItemItem) ? get_class($arrayOfVehicleActivityInfoItemVehicleActivityInfoItemItem) : sprintf('%s(%s)', gettype($arrayOfVehicleActivityInfoItemVehicleActivityInfoItemItem), var_export($arrayOfVehicleActivityInfoItemVehicleActivityInfoItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VehicleActivityInfoItem property can only contain items of type \StructType\VehicleActivityInfoItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VehicleActivityInfoItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleActivityInfoItem[] $vehicleActivityInfoItem
     * @return \ArrayType\ArrayOfVehicleActivityInfoItem
     */
    public function setVehicleActivityInfoItem(array $vehicleActivityInfoItem = array())
    {
        // validation for constraint: array
        if ('' !== ($vehicleActivityInfoItemArrayErrorMessage = self::validateVehicleActivityInfoItemForArrayConstraintsFromSetVehicleActivityInfoItem($vehicleActivityInfoItem))) {
            throw new \InvalidArgumentException($vehicleActivityInfoItemArrayErrorMessage, __LINE__);
        }
        if (is_null($vehicleActivityInfoItem) || (is_array($vehicleActivityInfoItem) && empty($vehicleActivityInfoItem))) {
            unset($this->VehicleActivityInfoItem);
        } else {
            $this->VehicleActivityInfoItem = $vehicleActivityInfoItem;
        }
        return $this;
    }
    /**
     * Add item to VehicleActivityInfoItem value
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleActivityInfoItem $item
     * @return \ArrayType\ArrayOfVehicleActivityInfoItem
     */
    public function addToVehicleActivityInfoItem(\StructType\VehicleActivityInfoItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VehicleActivityInfoItem) {
            throw new \InvalidArgumentException(sprintf('The VehicleActivityInfoItem property can only contain items of type \StructType\VehicleActivityInfoItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VehicleActivityInfoItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\VehicleActivityInfoItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\VehicleActivityInfoItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\VehicleActivityInfoItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\VehicleActivityInfoItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\VehicleActivityInfoItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VehicleActivityInfoItem
     */
    public function getAttributeName()
    {
        return 'VehicleActivityInfoItem';
    }
}
